package com.gxzc.zen.web.sys.controller

import com.gxzc.zen.api.sys.model.SysDic
import com.gxzc.zen.api.sys.service.ISysDicService
import com.gxzc.zen.common.base.BaseController
import com.gxzc.zen.common.config.json.annotation.ZenJsonFilter
import com.gxzc.zen.common.dto.ResponseDto
import org.slf4j.LoggerFactory
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.*

/**
 * 系统参数 控制器
 * @author NorthLan
 * @date 2018/3/9
 * @url https://noahlan.com
 */
@RestController
@RequestMapping("/sys/dic")
class SysDicController : BaseController() {
    companion object {
        private val logger = LoggerFactory.getLogger(SysDicController::class.java)
    }

    @Autowired
    private lateinit var sysDicService: ISysDicService

    @GetMapping("/list")
    @ZenJsonFilter(type = SysDic::class, filter = ["id", "createdBy"])
    fun getList(): ResponseEntity<*> {
        val ret = sysDicService.selectList()
        return ResponseEntity.ok(ResponseDto().apply {
            data["list"] = ret
        })
    }

    @GetMapping("{key}")
    @RequestMapping(method = [RequestMethod.GET])
    fun get(@PathVariable key: String): ResponseEntity<*> {
        val ret = sysDicService.getListByKey(key)
        return ResponseEntity.ok(ResponseDto().apply {
            data["list"] = ret
        })
    }

    @PutMapping("{key}")
    fun putDic(@PathVariable key: String, @RequestBody requestDto: ResponseDto): ResponseEntity<*> {
        // sysDicService.modifySysDic()
        return ResponseEntity.ok(null)
    }
}