package com.gxzc.zen.web.sys.controller

import com.baomidou.kisso.SSOToken
import com.baomidou.kisso.annotation.Action
import com.baomidou.kisso.annotation.Permission
import com.gxzc.zen.api.sys.service.ISysUserRoleService
import com.gxzc.zen.api.sys.service.ISysUserService
import com.gxzc.zen.common.base.BaseController
import com.gxzc.zen.common.dto.RequestDto
import com.gxzc.zen.common.dto.ResponseDto
import org.slf4j.LoggerFactory
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.*

/**
 * 用户相关控制器
 * @author NorthLan
 * @date 2018/3/2
 * @url https://noahlan.com
 */
@RestController
@RequestMapping("user")
class UserController : BaseController() {
    companion object {
        private val logger = LoggerFactory.getLogger(UserController::class.java)
    }

    @Autowired
    private lateinit var userRoleService: ISysUserRoleService

    @Autowired
    private lateinit var userService: ISysUserService


    @GetMapping("/info")
    @Permission(action = Action.Skip)
    fun userInfo(): ResponseEntity<*> {
        val token: SSOToken = getSSOToken()
        val userRoleList = userRoleService.getUserRoleListByUserId(token.uid.toLong())
        val userInfo = userService.getUserByIdCacheable(token.uid.toLong())

        return ResponseEntity.ok(ResponseDto().apply {
            data["info"] = mutableMapOf(
                    "account" to userInfo.account,
                    "username" to userInfo.username,
                    "id" to userInfo.id,
                    "position" to userInfo.position,
                    "address" to userInfo.address,
                    "staffNo" to userInfo.staffNo)
            data["roles"] = userRoleList
        })
    }

    @PutMapping("/info")
    fun modifyUserInfo(@RequestBody requestDto: RequestDto): ResponseEntity<*> {
        return ResponseEntity.ok(null)
    }
}